/***************************************************************************
 *            utilities.h
 *
 *  Thu Aug 26 01:23:48 2004
 *  Copyright  2004  User
 *  Email
 ****************************************************************************/

#ifndef _UTILITIES_H
#define _UTILITIES_H

#include <gtk/gtk.h>
#include <gdk/gdk.h>
// #include <gdk/gdkx.h>
#include <iostream>
#include "gettext.h"

enum
{
	STRUT_LEFT,
	STRUT_RIGHT,
	STRUT_TOP,
	STRUT_BOTTOM
};


enum u_menuType
{
	UMENU_NORMAL,
	UMENU_CHECK,
	UMENU_RADIO,
	UMENU_SEPARATOR,
	UMENU_HEADLINE
};


typedef struct _borderInfo
{
	long	left, right, top, bottom;
} borderInfo;


// structure for a menu item
typedef struct u_menuItem
{
	u_menuType  type;
	guint		id;		
	gchar* 		stockIcon;	
	char* 		title;	
	
	GtkMenu*	subMenu;
	
	gboolean	enabled,
				selected;
	
	guchar		groupID;
	GtkWidget** target;
	GdkPixbuf	*pixbuf;
};



void u_showAlertMessage(gchar* headline, gchar *message, gchar* iconstock);
gint u_showYesNoDialog(gchar* headline, gchar *message, gchar* iconstock, gboolean hasCancel);
gint u_showYNRememberDialog(gint dialogID, gchar* headline, GtkWidget *content, ...); 
void u_showFileWriteError(FILE* f);

GtkWidget* u_createImageButton(GtkWidget* label, GtkWidget* img);
void u_setWidgetBackground(GtkWidget *widget, gchar* col);
GtkWidget* u_createStockImageButton(gchar* stockIcon);
void u_setStockButtonImage(GtkWidget* button, gchar* stockIcon);
GtkWidget* u_createTextStockImageButton(gchar* text, gchar* stockIcon);
GtkWidget* u_changeTextStockImageButton(GtkWidget* w, gchar* text, gchar* stockIcon);

void u_createTableRow(GtkWidget* tbl, char* name1, GtkWidget** el1, char* name2, GtkWidget** el2, gint row);

GtkWidget* u_createTextView(GtkWidget** twidget);

GtkWidget* u_createHeadline(gchar* txt, gchar* alttxt, gchar* imageStock);

GtkMenu* u_createMenuList(u_menuItem* menulist, gchar elements, GtkSignalFunc cbfunc, gint menuID, gpointer data, gboolean showIcons);
void	 u_editMenuEntry(GtkWidget* menuEntry, gchar* newImage, gchar* newText);

GdkPixbuf* u_getPixbufFromStock(gchar* stockName, GtkIconSize size);

gchar* u_convertSize2Readable(gint size);

// X11 functions
borderInfo*	u_getDisplayBorders();
gboolean	u_dockWindow(GtkWidget* wnd, gchar dir);
void		u_getDisplaySize(GtkWidget* w, gint* width, gint* height);

#endif /* _UTILITIES_H */
