/***************************************************************************
 *            contactsselection.cpp
 *
 *  Tue Jun  7 02:30:18 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

#include "contactsselection.h"


contactsSelection::contactsSelection(IMUserDaemon *selectedUser)
{
	GList				*search,
						*searchOwners,
						*searchGroups,
						*owners;
	contactListGroup	*groupEntry;
	contactListUser		*userEntry;
	IMUserDaemon		*user;
	groupInfo			*currentGroup;
		
	owners = IO_getOwnerList();
	
	contacts = new contactList(NULL);
	contacts->showEntries(CVIEW_GROUPS | CVIEW_NOEMPTYGROUPS);
	contacts->setCheckSelectionMode(TRUE);
	
	// get all groups
	search = IO_getGroupManager()->groups;
	while(search)
	{
		currentGroup = (groupInfo*)search->data;
		
		groupEntry = new contactListGroup(currentGroup->icqndID, currentGroup->name, NULL);
		groupEntry->setGroupOpened(TRUE);
		contacts->addChild(groupEntry);
		
		search = search->next;
	}		
	
	
	searchOwners = owners;
	while(searchOwners)
	{			
		// get all users
		search = ((IMOwnerDaemon*)searchOwners->data)->users;
		while(search)
		{
			user = (IMUserDaemon*)search->data;
			
			searchGroups = user->groups;
			while(searchGroups)
			{	
				groupEntry = (contactListGroup*)contacts->findEntryByID(((groupInfo*)searchGroups->data)->icqndID, CE_GROUP);
				
				if (groupEntry)
				{
					userEntry = new contactListUser(user->info->licqID, 
													user->info->formattedAlias, 
													i_getIcons()->getUserStatusPixbuf(user),
													user->info->status, 
													user, 
													NULL);
					
					if (user == selectedUser)
						userEntry->setSelected(TRUE);
					
					groupEntry->addChild(userEntry);
				}
				
				searchGroups = searchGroups->next;
			}
			
			search = search->next;
		}
		
		searchOwners = searchOwners->next;
	}
	
	
	selectedEntries = NULL;
	
	widget = contacts->listWidget;
}



contactsSelection::~contactsSelection()
{

}



GList* contactsSelection::getSelectedEntries(contactListEntry* root, GList* results)
{
	GList	*search,
			*list;
	contactListEntry* entry;
	
	if (!root)
		root = contacts;
		
	list = results;
	
	search = root->children;
	while(search)
	{
		entry = (contactListEntry*)search->data;
		if (entry->type == CE_USER && entry->selected)
		{
			list = g_list_append(list, entry);
		}
		if (entry->children)
			list = getSelectedEntries(entry, list);
		
		search = search->next;
	}
	
	
	if (root == contacts)
	{
		if (selectedEntries)
			g_list_free(selectedEntries);
	
		selectedEntries = list;
	}
	
	return list;
}
